﻿

Public Class Form1
    Public Delegate Sub Capture_Data(ByVal Prop_data As String)
    Dim in_data As String
    Dim WithEvents serialPort As New IO.Ports.SerialPort
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ts_connected.Text = "Disconnected"
        ' Insert Load Coad Here
        For i As Integer = 0 To My.Computer.Ports.SerialPortNames.Count - 1
            cb_ports.Items.Add(My.Computer.Ports.SerialPortNames(i))
        Next
        lbl_status.Text = "Load Successful"
    End Sub

    Private Sub btn_forward_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btn_forward.Click
        ' send command to go forward
        If SerialPort1.IsOpen Then
            SerialPort1.Write("fw")
            lbl_status.Text = "Moving Forward"
        End If

    End Sub

    Private Sub btn_left_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btn_left.Click
        ' send command to go left
        If SerialPort1.IsOpen Then
            SerialPort1.Write("lft")
            lbl_status.Text = "Turning Left at current speed"
        End If

    End Sub

    Private Sub btn_reverse_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btn_reverse.Click
        ' send command to reverse
        If SerialPort1.IsOpen Then
            SerialPort1.Write("bw")
            lbl_status.Text = "Going Reverse"
        End If

    End Sub

    Private Sub btn_right_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btn_right.Click
        ' send command to go right
        If SerialPort1.IsOpen Then
            SerialPort1.Write("rt")
            lbl_status.Text = "Turning right at current speed"
        End If

    End Sub

    Private Sub btn_spinccw_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btn_spinccw.Click
        ' send command to spin counter-clockwise
        If SerialPort1.IsOpen Then
            SerialPort1.Write("ccw")
            lbl_status.Text = "Spinning Counter Clockwise"
        End If

    End Sub

    Private Sub btn_spincw_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btn_spincw.Click
        ' send command to spin clockwise
        If SerialPort1.IsOpen Then
            SerialPort1.Write("cw")
            lbl_status.Text = "Spinning Clockwise"
        End If

    End Sub

    Private Sub btn_stop_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btn_stop.Click
        ' send command to stop
        If SerialPort1.IsOpen Then
            SerialPort1.Write("stop")
            lbl_status.Text = "Stopped"
        End If
           End Sub

   
    Private Sub btn_connect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_connect.Click
        If SerialPort1.IsOpen Then
            SerialPort1.Close()
        End If
        Try
            With SerialPort1
                .PortName = cb_ports.Text
                .BaudRate = 9600
                .Parity = IO.Ports.Parity.None
                .DataBits = 8
                .StopBits = IO.Ports.StopBits.One
                .Handshake = IO.Ports.Handshake.None
                .ReceivedBytesThreshold = 1
            End With
            SerialPort1.Open()
            ts_connected.Text = cb_ports.Text & " connected."
            btn_connect.Enabled = False
            btn_disconnect.Enabled = True
        Catch ex As Exception
            MsgBox(ex.ToString)
        End Try
    End Sub

    Private Sub btn_disconnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_disconnect.Click
        Try
            SerialPort1.Close()
            ts_connected.Text = SerialPort1.PortName & " disconnected."
            btn_connect.Enabled = True
            btn_disconnect.Enabled = False
        Catch ex As Exception
            MsgBox(ex.ToString)
        End Try
    End Sub
    Private Sub DataReceived(ByVal sender As Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles SerialPort1.DataReceived
        Do
            in_data = SerialPort1.ReadByte
            Dim new_delegate As New Capture_Data(AddressOf Text_Out)
            Me.RichTextBox1.Invoke(new_delegate, in_data)
        Loop Until SerialPort1.BytesToRead < 1
    End Sub
    Public Sub Text_Out(ByVal text As Int16)
        Me.RichTextBox1.AppendText(Chr(text))
    End Sub


    Private Sub tb_speed_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_speed.Scroll
        '      SerialPort1.Write("spd" + (tb_speed.Value * 2).ToString)


    End Sub

    
    Private Sub btn_speed_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_speed.Click
        SerialPort1.Write("spd" + (tb_speed.Value * 2).ToString)
    End Sub
End Class
